#!/bin/bash

echo "Updates postgresql 9.2 to 9.6"
VERSION=$(rpm -qa --queryformat "%{VERSION}\n" postgresql-server)
if ! [[ "$VERSION" =~ 9.2. ]]; then 
    echo "The postgres version is $VERSION, skip upgrade";
    exit 0
fi

# ( installed from parent script)
# yum  --enablerepo=spprepo install postgresql96-server
# 

systemctl stop virgo

sed -i.bak 's#Environment=PGDATA=.*#Environment=PGDATA=/data/postgres_96#g' /usr/lib/systemd/system/postgresql*.service

systemctl daemon-reload

/usr/pgsql-9.6/bin/postgresql96-setup initdb


mv /usr/bin/pg_ctl{,-orig}


echo '#!/bin/bash' > /usr/bin/pg_ctl
echo '"$0"-orig "${@/unix_socket_directory/unix_socket_directories}"' >> /usr/bin/pg_ctl
chmod +x /usr/bin/pg_ctl


# stop old server
systemctl stop postgresql

cd /tmp
su -c "/usr/pgsql-9.6/bin/pg_upgrade -v -b /usr/bin/ -B /usr/pgsql-9.6/bin/ -d /data/postgres -D /data/postgres_96" postgres
if [ $? != 0 ]; then
    "The postgresql upgrade failed" 
    exit 1
fi



# Rollback pg_ctl
mv -f /usr/bin/pg_ctl{-orig,}

# copy config from old version
su -c" cp /data/postgres/*.conf /data/postgres_96" postgres

systemctl start postgresql-9.6
systemctl enable postgresql-9.6
systemctl disable postgresql

yum remove postgresql -y

echo 'export PATH=$PATH:/usr/pgsql-9.6/bin' >> /etc/bashrc

ln -s  /usr/pgsql-9.6/bin/pg_dump  /usr/bin/pg_dump 
