#!/bin/bash

# Check for any cloud devices or cloud pools. We cannot cleanly unmount these
# so we will fail the upgrade and recommend that the user reboot the system
# to clear them before retrying the upgrade.


NUM_TCMU=$(lsscsi | grep -w TCMU | wc -l 2>/dev/null)
if [[ -n ${NUM_TCMU} ]] && [[ "${NUM_TCMU}" -ne "0" ]]; then
	echo "Error: Cannot upgrade while there are cloud-backed devices present on the host."
	echo "Please reboot the system to clear the devices and then retry the upgrade."
	exit 1
fi

NUM_OPOOLS=$(zpool list 2>/dev/null | grep opool | wc -l 2>/dev/null)
if [[ -n ${NUM_OPOOLS} ]] && [[ "${NUM_OPOOLS}" -ne "0" ]]; then
	echo "Error: Cannot upgrade while there are cloud offload pools present on the host."
	echo "Please reboot the system to clear the devices and then retry the upgrade."
	exit 1
fi

NUM_RPOOLS=$(zpool list 2>/dev/null | grep rpool | wc -l 2>/dev/null)
if [[ -n ${NUM_RPOOLS} ]] && [[ "${NUM_RPOOLS}" -ne "0" ]]; then
	echo "Error: Cannot upgrade while there are cloud restore pools present on the host."
	echo "Please reboot the system to clear the devices and then retry the upgrade."
	exit 1
fi


